/****************************************************************************\
*                                                                            *
*  FGFW5.CPP                                                                 *
*  FGFW5U.CPP                                                                *
*                                                                            *
*  Demonstrate how to display centered text within a rectangle.              *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGFW5U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   int dx, dy;
   int midx, midy;
   char message_text[14];

   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(640,480);
   fg_vbopen(hvb);
   fg_vbcolors();

   if (fgf_load("AUSTIN36.FGF") == 0)
   {
      Application->MessageBox("Unable to load font file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }

   fg_setcolor(255);
   fg_fillpage();

   midx = fg_getmaxx() / 2;
   midy = fg_getmaxy() / 2;
   lstrcpy(message_text,"TEXT IN A BOX");
   dx = fgf_width(message_text,13) / 2 + 4;
   dy = fgf_height(message_text,13) / 2 + 4;

   fg_setcolor(17);
   fg_rect(midx-dx,midx+dx,midy-dy,midy+dy);
   fg_setcolor(20);
   fg_move(midx,midy);
   fgf_justify(0,0);
   fgf_print(message_text,13);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fgf_unload(-1);
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
